<?php
//========= KONSTANTOS =========
    $WEB_SERVISAS = "https://www.epaslaugos.lt/portal-test/authenticationServices/auth";
    $AUTHENTICATION_URL = "https://www.epaslaugos.lt/portal-test/external/services/authentication/v2/";
    $SOAP_REQ = '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:aut="http://www.epaslaugos.lt/services/authentication" xmlns:xd="http://www.w3.org/2000/09/xmldsig#">
    <soapenv:Header/>
    <soapenv:Body>
      %s
    </soapenv:Body>
    </soapenv:Envelope>';
    $TICKET_REGEX = "#<authentication:ticket>.+?</authentication:ticket>#";
//==============================
/**
  Funkcija skirta ištraukti bilietą iš atsakymo nusiuntus atitinkamą užklausą.
*/
function extractTicket($data) {
    global $TICKET_REGEX;

    preg_match($TICKET_REGEX, $data, $matches);
    $rawTicket = $matches[0];
    $rawTicket = str_replace("<authentication:ticket>", "", $rawTicket);
    $ticket = str_replace("</authentication:ticket>", "", $rawTicket);
    return $ticket;
}
//==============================
/**
  Funkcija skirta gražiai suformatuoti vardą, pavardę bei gimimo datą iš XML'o
  kuris gaunamas paskutiniu etapu.
*/
function formatName($rawXml) {
    $rtnStr = '';
    
    //sukuriam objektą ir užkraunam dokumentą paduotą per funkcijos argumentą
    $domDoc = new DOMDocument();
    $domDoc->loadXml($rawXml);

    $nodeSet = $domDoc->getElementsByTagName('userInformation'); // gaunam visus blokus pagal šitą tagname'ą - vardas ir pavardė
    $vardas = $nodeSet->item(0)->getElementsByTagName('stringValue')->item(0)->nodeValue;
    $pavarde = $nodeSet->item(1)->getElementsByTagName('stringValue')->item(0)->nodeValue;
    $gimimoData = $nodeSet->item(2)->getElementsByTagName('dateValue')->item(0)->nodeValue;
    $gimimoData = substr($gimimoData, 0, -1); // pašalinam Z raidę nuo galo

    $nodeSet = $domDoc->getElementsByTagName('authenticationAttribute'); // gaunam asmens kodo bloką
    $asmensKodas = $nodeSet->item(0)->getElementsByTagName('value')->item(0)->nodeValue;

    // gražiai suformatuojam išvedimą
    $rtnStr = 'Vardas: '.$vardas.'<br />Pavardė: '.$pavarde.'<br />Gimimo data: '.$gimimoData.'<br />Asmens kodas: '.$asmensKodas;

    return $rtnStr;
}
//==============================
/**
  Funkcija skirta pimam etapui, inicijuoti autentifikaciją.
  Gaunama $soap_req pilna SOAP'o užklausa, kurią siunčiame
  per POST'ą į $authentication_url iš kur gaunamas SOAP'o atsakymas
  su ticket'u. Iš čia ištraukiamas ticket'as ir siunčiamas į $web_servisas
  per GET'ą. Nusiuntus vartotojas būna nukreipiamas į VAIISIS sistemą.
*/
function authenticate($soap_req, $web_servisas, $authentication_url) {
  $contextData = array ('Connection' => 'Keep-Alive',
                        'Accept-Encoding' => 'gzip,deflate',
                        'Content-Type' => 'text/xml;charset=UTF-8',
                        'SOAPAction' => 'http://www.epaslaugos.lt/services-test/authenticationServiceProvider/initAuthentication',
                        'Content-Length' => strlen($soap_req),
                        'Host' => 'www.epaslaugos.lt',
                        'User-Agent' => 'Apache-HttpClient/4.1.1 (java 1.5)');

  $soap_do = curl_init();
  curl_setopt($soap_do, CURLOPT_URL, $web_servisas);
  curl_setopt($soap_do, CURLOPT_CONNECTTIMEOUT, 10);
  curl_setopt($soap_do, CURLOPT_TIMEOUT, 10);
  curl_setopt($soap_do, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($soap_do, CURLOPT_SSL_VERIFYPEER, false);
  curl_setopt($soap_do, CURLOPT_SSL_VERIFYHOST, false);
  curl_setopt($soap_do, CURLOPT_POST, true);
  curl_setopt($soap_do, CURLOPT_POSTFIELDS, $soap_req);
  curl_setopt($soap_do, CURLOPT_HTTPHEADER, $contextData);
  $resp = curl_exec($soap_do);
  $ticket = extractTicket($resp);
  // echo 'Location: '.$authentication_url.'?ticket='.$ticket; die();
  header('Location: '.$authentication_url.'?ticket='.$ticket);
}
//==============================
/**
  Funkcija skirta antram etapui, gauti vartotojo po autentifikacijos duomenis.
  Gaunama $soap_req pilna SOAP'o užklausa, kurią siunčiame
  per POST'ą į $authentication_url iš kur gaunamas SOAP'o atsakymas
  su vartotojo duomenimis ir vykdoma skriptas toliau.
*/
function getUserData($soap_req, $web_servisas, $authentication_url) {
  $contextData =  array ('Connection' => 'Keep-Alive',
                        'Accept-Encoding' => 'gzip,deflate',
                        'Content-Type' => 'text/xml;charset=UTF-8',
                        'SOAPAction' => 'https://www.epaslaugos.lt/services-test/authenticationServiceProvider/getAuthenticationData',
                        'Content-Length' => strlen($soap_req),
                        'Host' => 'www.epaslaugos.lt',
                        'User-Agent' => 'Apache-HttpClient/4.1.1 (java 1.5)');

  $soap_do = curl_init();
  curl_setopt($soap_do, CURLOPT_URL, $web_servisas);
  curl_setopt($soap_do, CURLOPT_CONNECTTIMEOUT, 10);
  curl_setopt($soap_do, CURLOPT_TIMEOUT, 10);
  curl_setopt($soap_do, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($soap_do, CURLOPT_SSL_VERIFYPEER, false);
  curl_setopt($soap_do, CURLOPT_SSL_VERIFYHOST, false);
  curl_setopt($soap_do, CURLOPT_POST, true);
  curl_setopt($soap_do, CURLOPT_POSTFIELDS, $soap_req);
  curl_setopt($soap_do, CURLOPT_HTTPHEADER, $contextData);
  $resp = curl_exec($soap_do);
  // header('Content-Type:text/xml');
  echo formatName($resp);
}
//==============================

include('generateSignatureJava.php');
if (isset($_POST['ticket'])) {
  $reqDataXml = sprintf($SOAP_REQ, generateDataReqXML($_POST['ticket']));
  getUserData($reqDataXml, $WEB_SERVISAS, $AUTHENTICATION_URL);
} else {
  $reqXml = sprintf($SOAP_REQ, generateReqXML());
  authenticate($reqXml, $WEB_SERVISAS, $AUTHENTICATION_URL);
}

?>